
<p align="center">
<img src="https://user-images.githubusercontent.com/71620349/185368586-aed82d30-1534-453d-86ff-ecfa9d0f35bd.png" width = "256"  div align=center />

</p>

<p align="center">
    <a href="https://knowstreaming.com">产品官网</a> | 
    <a href="https://github.com/didi/KnowStreaming/releases">下载地址</a> | 
    <a href="https://doc.knowstreaming.com/product">文档资源</a> | 
    <a href="https://demo.knowstreaming.com">体验环境</a> 
</p>

<p align="center">
<!--最近一次提交时间-->
<a href="https://img.shields.io/github/last-commit/didi/KnowStreaming">
    <img src="https://img.shields.io/github/last-commit/didi/KnowStreaming" alt="LastCommit">
</a>

<!--最新版本-->
<a href="https://github.com/didi/KnowStreaming/blob/master/LICENSE">
    <img src="https://img.shields.io/github/v/release/didi/KnowStreaming" alt="License">
</a>

<!--License信息-->
<a href="https://github.com/didi/KnowStreaming/blob/master/LICENSE">
    <img src="https://img.shields.io/github/license/didi/KnowStreaming" alt="License">
</a>

<!--Open-Issue-->
<a href="https://github.com/didi/KnowStreaming/issues">
    <img src="https://img.shields.io/github/issues-raw/didi/KnowStreaming" alt="Issues">
</a>

<!--知识星球-->
<a href="https://z.didi.cn/5gSF9">
    <img src="https://img.shields.io/badge/join-%E7%9F%A5%E8%AF%86%E6%98%9F%E7%90%83-red" alt="Slack">
</a>

</p>


---


## `Know Streaming` 简介

`Know Streaming`是一套云原生的Kafka管控平台，脱胎于众多互联网内部多年的Kafka运营实践经验，专注于Kafka运维管控、监控告警、资源治理、多活容灾等核心场景。在用户体验、监控、运维管控上进行了平台化、可视化、智能化的建设，提供一系列特色的功能，极大地方便了用户和运维人员的日常使用，让普通运维人员都能成为Kafka专家。

我们现在正在收集 Know Streaming 用户信息，以帮助我们进一步改进  Know Streaming。
请在 [issue#663](https://github.com/didi/KnowStreaming/issues/663) 上提供您的使用信息来支持我们：[谁在使用 Know Streaming](https://github.com/didi/KnowStreaming/issues/663) 



整体具有以下特点：

- 👀 &nbsp;**零侵入、全覆盖**
  - 无需侵入改造 `Apache Kafka` ，一键便能纳管 `0.10.x` ~ `3.x.x` 众多版本的Kafka，包括 `ZK` 或 `Raft` 运行模式的版本，同时在兼容架构上具备良好的扩展性，帮助您提升集群管理水平；

- 🌪️ &nbsp;**零成本、界面化**
  - 提炼高频 CLI 能力，设计合理的产品路径，提供清新美观的 GUI 界面，支持 Cluster、Broker、Zookeeper、Topic、ConsumerGroup、Message、ACL、Connect 等组件 GUI 管理，普通用户5分钟即可上手；

- 👏 &nbsp;**云原生、插件化**
  - 基于云原生构建，具备水平扩展能力，只需要增加节点即可获取更强的采集及对外服务能力，提供众多可热插拔的企业级特性，覆盖可观测性生态整合、资源治理、多活容灾等核心场景；

- 🚀 &nbsp;**专业能力**
  - 集群管理：支持一键纳管，健康分析、核心组件观测 等功能；
  - 观测提升：多维度指标观测大盘、观测指标最佳实践 等功能； 
  - 异常巡检：集群多维度健康巡检、集群多维度健康分 等功能； 
  - 能力增强：集群负载均衡、Topic扩缩副本、Topic副本迁移 等功能；


&nbsp;
**产品图**

<p align="center">

<img src="http://img-ys011.didistatic.com/static/dc2img/do1_sPmS4SNLX9m1zlpmHaLJ" width = "768" height = "473" div align=center />

</p>




## 文档资源

**`开发相关手册`**

- [打包编译手册](docs/install_guide/源码编译打包手册.md)
- [单机部署手册](docs/install_guide/单机部署手册.md)
- [版本升级手册](docs/install_guide/版本升级手册.md)
- [本地源码启动手册](docs/dev_guide/本地源码启动手册.md)
- [页面无数据排查手册](docs/dev_guide/页面无数据排查手册.md)

**`产品相关手册`**

- [产品使用指南](docs/user_guide/用户使用手册.md)
- [2.x与3.x新旧对比手册](docs/user_guide/新旧对比手册.md)
- [FAQ](docs/user_guide/faq.md)


**点击 [这里](https://doc.knowstreaming.com/product)，也可以从官网获取到更多文档**





## 成为社区贡献者

1. [贡献源码](https://doc.knowstreaming.com/product/10-contribution) 了解如何成为 Know Streaming 的贡献者
2. [具体贡献流程](https://doc.knowstreaming.com/product/10-contribution#102-贡献流程)
3. [开源激励计划](https://doc.knowstreaming.com/product/10-contribution#105-开源激励计划)
4. [贡献者名单](https://doc.knowstreaming.com/product/10-contribution#106-贡献者名单)


获取KnowStreaming开源社区证书。

## 加入技术交流群

**`1、知识星球`**

<p align="left">
<img src="https://user-images.githubusercontent.com/71620349/185357284-fdff1dad-c5e9-4ddf-9a82-0be1c970980d.JPG"  height = "180" div align=left />
</p>       

<br/>
<br/>
<br/>
<br/>
<br/>
<br/>
<br/>
<br/>

👍 我们正在组建国内最大，最权威的 **[Kafka中文社区](https://z.didi.cn/5gSF9)**

在这里你可以结交各大互联网的 Kafka大佬 以及 4000+ Kafka爱好者，一起实现知识共享，实时掌控最新行业资讯，期待 👏 &nbsp; 您的加入中～ https://z.didi.cn/5gSF9

有问必答~！ 互动有礼~！

PS: 提问请尽量把问题一次性描述清楚，并告知环境信息情况～！如使用版本、操作步骤、报错/警告信息等，方便大V们快速解答～

&nbsp;

**`2、微信群`**

微信加群：添加`mike_zhangliang`、`PenceXie` 、`szzdzhp001`的微信号备注KnowStreaming加群。
<br/>

加群之前有劳点一下 star，一个小小的 star 是对KnowStreaming作者们努力建设社区的动力。

感谢感谢！！！

<img width="116" alt="wx" src="https://user-images.githubusercontent.com/71620349/192257217-c4ebc16c-3ad9-485d-a914-5911d3a4f46b.png">

## Star History

[![Star History Chart](https://api.star-history.com/svg?repos=didi/KnowStreaming&type=Date)](https://star-history.com/#didi/KnowStreaming&Date)

